.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

NoButtons           equ     9
.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'Rich Edit Control Example v1.0',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ Toolbar related +++++

hToolbar        dd          ?
ToolbarClass    db      'ToolbarWindow32',0
TBButtons       TBBUTTON    <NULL,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <NULL,1,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <NULL,2,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <NULL,NULL,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                TBBUTTON    <NULL,3,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <NULL,4,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <NULL,5,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                TBBUTTON    <NULL,NULL,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                TBBUTTON    <NULL,6,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>


szRichEdit      db      'riched20.dll',0
hRichEditLib    dd          ?
RichEditClass   db      'RichEdit20A',0
hRichEdit       dd          ?

rect        RECT        <>
StreamStruct    EDITSTREAM  <0,0,offset StreamInProc>
szFile      db      '.\re2.asm',0
hFile       dd          ?

szError     db      'Error!!!',0
szErrorIHV  db      'CreateFile returned INVALID_HANDLE_VALUE',0
szErrorCLL  db      'Couldnt Load RichEdit Library',0
.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  InitCommonControls
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW+WS_CLIPCHILDREN+WS_CLIPSIBLINGS,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local    ToolbarReservedY:DWORD
    
    .if uMsg==WM_DESTROY
Quit_App:    
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  LoadLibrary,addr szRichEdit
            .if eax!=NULL
                mov     hRichEditLib,eax
                invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+TBSTYLE_ALTDRAG,\
                            0,0,0,0,hWnd,NULL,hInstance,NULL
                mov     hToolbar,eax
                invoke  SendMessage,eax,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
                invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoButtons,addr TBButtons
                invoke	SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL                                            
                invoke  GetClientRect,hWnd,addr rect
                invoke  GetSystemMetrics,SM_CYEDGE
                shl     eax,1
                push    eax
                invoke  SendMessage,hToolbar,TB_GETBUTTONSIZE,NULL,NULL
                pop     ebx
                shr     eax,16
                add     eax,ebx
                add     eax,2
                mov     ToolbarReservedY,eax
                add     rect.top,eax
                sub     rect.bottom,eax
                invoke  CreateWindowEx,NULL,addr RichEditClass,NULL,WS_VISIBLE+WS_CHILD+ES_MULTILINE+ES_WANTRETURN\
                            +WS_HSCROLL+WS_VSCROLL,0,rect.top,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                mov hRichEdit,eax
                invoke  SendMessage,hRichEdit,EM_SETMODIFY,0,0
                invoke  SendMessage,hRichEdit,EM_EMPTYUNDOBUFFER,0,0
                invoke  CreateFile,addr szFile,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,\
                            FILE_ATTRIBUTE_NORMAL,NULL
                .if eax!=INVALID_HANDLE_VALUE                            
                    mov hFile,eax
                    mov StreamStruct.dwCookie,eax
                    invoke  SendMessage,hRichEdit,EM_STREAMIN,SF_TEXT,addr StreamStruct                            
                    invoke  CloseHandle,hFile
                    invoke  SendMessage,hRichEdit,EM_SETMODIFY,TRUE,NULL
                .else
                    invoke  MessageBox,hWnd,addr szErrorIHV,addr szError,MB_OK
                .endif                                        
            .else
                invoke  MessageBox,hWnd,addr szErrorCLL,addr szError,MB_OK
                jmp     Quit_App
            .endif
        .endif            
    .elseif uMsg==WM_SIZE
               invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL
               mov     eax,lParam
               push    eax
               movzx   eax,ax
               pop     ebx
               shr     ebx,16
               sub     ebx,ToolbarReservedY
               invoke  MoveWindow,hRichEdit,0,ToolbarReservedY,eax,ebx,TRUE
        
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

StreamInProc    PROC    dwCookie:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD
    
    invoke  ReadFile,dwCookie,lpBuff,cb,pcb,NULL
    xor eax,1
    ret

StreamInProc    endp

StreamOutProc   PROC    dwCookie:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD

    invoke  WriteFile,dwCookie,lpBuff,cb,pcb,NULL
    xor     eax,TRUE
    ret
    
StreamOutProc   endp
end start                                            
